﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.IO;
using System.Windows.Forms;

class Program {
    [STAThread]
    static void Main(string[] args) {
        Console.WriteLine("クリップボード内の画像をデスクトップに保存します。");
        Image img = Clipboard.GetImage();
        if(img != null) {
            int parsedR;
            ImageFormat format = ImageFormat.Bmp;
            while(!(tryIntput(out parsedR) && 0 <= parsedR && parsedR <= 9)) ;
            switch(parsedR) {
            case 0:
                format = ImageFormat.Bmp;
                break;
            case 1:
                format = ImageFormat.Gif;
                break;
            case 2:
                format = ImageFormat.Jpeg;
                break;
            case 3:
                format = ImageFormat.Png;
                break;
            case 4:
                format = ImageFormat.Tiff;
                break;
            }
           save(img, format);
        } else {
            endNoImage();
        }
    }

    static bool tryIntput(out int parsedInt) {
        int outInt;
        Console.Write("フォーマットを選択して下さい。0:bmp 1:gif 2:jpeg 3:png 4:tiff(0 - 4) ");
        bool r = int.TryParse(Console.ReadLine(),out outInt);
        parsedInt = outInt;
        return r;
    }

    static string getSavePath(string extension) {
        string path = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory) + @"\ClpBdImg";
        for(int i = 0; ; i++) {
            string returnPath = path + i.ToString() + extension;
            if(!File.Exists(returnPath)) return returnPath;
        }
    }    
    
    static void save(Image img, ImageFormat format) {
        string savePath = getSavePath(("." + format.ToString()).ToLower());
        img.Save(savePath, format);
        endImageSaved(savePath);
    }

    static void endImageSaved(string savedPath) {
        Console.Write(savedPath + "に保存しました。");
        Console.ReadLine();
    }

    static void endNoImage() {
        Console.WriteLine("クリップボードに画像がありません。");
        Console.Write("アプリケーションを終了します。");
        Console.ReadLine();
        Application.Exit();
    }
}